import 'package:lambda/flurine_lambda.dart';

const TIME = 'tm';
const CONCAT = 'cc';

void main() async {
  Handler.registerMany({
    CONST: () => ConstHandler(),
    TIME: () => TimeHandler(),
    CONCAT: () => ConcatHandler(),
  });
  await Vein.init();
  final lambda = Lambda(CONCAT, [
    Lambda(
      TIME,
      [
        Lambda(CONST, [Duration(seconds: 4)])
      ],
    ),
    Lambda(
      CONST,
      [
        ' -- ',
      ],
    ),
    Lambda(
      TIME,
      [
        Lambda(CONST, [Duration(seconds: 5)])
      ],
    ),
  ]);
  await lambda.execute();
  lambda.vein.listen(listen);
  await Future.delayed(Duration(
    seconds: 20,
  ));
  await (lambda.params[1] as Lambda).update(
      Lambda(CONCAT, [
        Lambda(
          TIME,
          [
            Lambda(CONST, [Duration(seconds: 4)])
          ],
        ),
        Lambda(
          CONST,
          [
            ' -- ',
          ],
        ),
        Lambda(
          TIME,
          [
            Lambda(CONST, [Duration(seconds: 5)])
          ],
        ),
      ])
  );
}

void listen(data) {
  print(data);
}

class TimeHandler extends Handler {

  @override
  Future compute() async {
    return DateTime.now().second;
  }

  @override
  Duration get repeatingDuration => params.last;
}

class CounterHandler extends Handler {

  @override
  Duration get repeatingDuration => null;

  int begin, end, step,current;

  @override
  set params(List params) {
    this.params = params;
    begin = params[0];
    end = params[1];
    step = params[2];
    current = params[3];
  }

  @override
  Future compute() async {
    if (current == null || current > end) current = begin;
    // ignore: omit_local_variable_types
    int temp = current;
    current = current + step;
    return temp;
  }
}

class ConcatHandler extends Handler{

  @override
  Duration get repeatingDuration => null;

  @override
  Future compute() async{
    return params.join();
  }

}
